//+---------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                             MakeListOfInstruments.mqh |
//|                                                                                                                                   hoz |
//|                                                                                                                                       |
//+---------------------------------------------------------------------------------------------------------------------------------------+
#ifndef MAKELISTOFINSTRUMENTS_H
#define MAKELISTOFINSTRUMENTS_H

#property copyright "hoz"
#property link      ""
#property strict
// ==================================================      =================================================+
#include    <HOZ_Code\Classes\HandlingWithErrors.mqh>
#include    <HOZ_Code\Classes\Logging.mqh>
#include    <HOZ_Code\Classes\BaseInfo.mqh>
#include    <HOZ_Code\Classes\ManipulationsOfArrays.mqh>
//+=======================================================================================================================================+
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|                                                                                          |
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+=======================================================================================================================================+
class MakeListOfInstruments
{
   private:
      int      CntOfSMB;               //   
      string   WorkingSMB[];           //   

      //----  Input
      string   ListOfWorkingSMB;       //   
      string   ListOfMagic;            //    
      string   BaseCurrencyList;       //   
      string   BadCurrencyList;        // "׸"   ( )
      int      MaxSpread;              //  
   public:
      //----   
               MakeListOfInstruments (void);
              ~MakeListOfInstruments (void);

      //---- 
      void     SetListOfWorkingSMB (const string fs_ListOfWorkingSMB);
      void     SetListOfMagic (const string fs_ListOfMagic);
      void     SetBaseCurrensyList (const string fs_BaseCurrencyList);
      void     SetBadCurrencyList (const string fs_BadCurrencyList);
      void     SetMaxSpread (const int fi_MaxSpread);

      //---- 
      string   GetListOfWorkingSMB (void) const;
      string   GetListOfMagic (void) const;
      string   GetBaseCurrencyList (void) const;
      string   GetBadCurrencyList (void) const;
      int      GetMaxSpread (void) const;

      //---- 
      int      CreatWorkingSMBArray (string& fsa_WorkingSMB[], string fs_ListOfWorkingSMB, string fs_BaseCurrency,
                                         string fs_BadCurrency, int fi_MAXspread = 0, string fs_Delimiter = ",");
      int      ListOfSMB (string& fsa_SMB[], bool fb_Looking);
      int      CheckPresenceSMBInMarket (string& fsa_WorkingSMB[]);
};

//---- C   MakeListOfInstruments
MakeListOfInstruments CMakeListOfInstruments;
//=========================================================================================================================================
//  . ====================================================================================================================
MakeListOfInstruments::MakeListOfInstruments (void)
{
   //----    input- ----------------
   SetListOfWorkingSMB (is_ListOfWorkingSMB);
   SetListOfMagic (is_ListOfMagic);
   SetBaseCurrensyList (is_BaseCurrencyList);
   SetBadCurrencyList (is_BadCurrencyList);
   SetMaxSpread (ii_MaxSpread);
   
   //----         
   CntOfSMB = CreatWorkingSMBArray (WorkingSMB, ListOfWorkingSMB, BaseCurrencyList, BadCurrencyList, MaxSpread);
   
   //----     
   ListOfWorkingSMB = CArraysMan.CreatStrFromArray (WorkingSMB, ",");
}
//=========================================================================================================================================
//  . =====================================================================================================================
MakeListOfInstruments::~MakeListOfInstruments (void) {
}
//+=======================================================================================================================================+
//|                                                                                                                                |
//+=======================================================================================================================================+
//---- SetListOfWorkingSymbols
MakeListOfInstruments::SetListOfWorkingSMB (const string fs_ListOfWorkingSMB)
{
   ListOfWorkingSMB = fs_ListOfWorkingSMB;
}
//---- ListOfMagic
MakeListOfInstruments::SetListOfMagic(const string fs_ListOfMagic)
{
   ListOfMagic = fs_ListOfMagic;
}
//---- SetBaseCurrensyList
MakeListOfInstruments::SetBaseCurrensyList (const string fs_BaseCurrencyList)
{
   BaseCurrencyList = fs_BaseCurrencyList;
}
//---- SetBadCurrencyList
MakeListOfInstruments::SetBadCurrencyList (const string fs_BadCurrencyList)
{
   BadCurrencyList = fs_BadCurrencyList;
}
//---- SetMaxSpread
MakeListOfInstruments::SetMaxSpread (const int fi_MaxSpread)
{
   MaxSpread = fi_MaxSpread;
}
//+=======================================================================================================================================+
//|                                                                                                                                |
//+=======================================================================================================================================+
string MakeListOfInstruments::GetListOfWorkingSMB (void) const
{
   return (ListOfWorkingSMB);
}
string MakeListOfInstruments::GetListOfMagic (void) const
{
   return (ListOfMagic);
}
string MakeListOfInstruments::GetBaseCurrencyList (void) const
{
   return (BaseCurrencyList);
}
string MakeListOfInstruments::GetBadCurrencyList (void) const
{
   return (BadCurrencyList);
}
int MakeListOfInstruments::GetMaxSpread (void) const
{
   return (MaxSpread);
}
//=========================================================================================================================================
// 1.1         . =========================================================================
int MakeListOfInstruments::CreatWorkingSMBArray (string& fsa_WorkingSMB[],           //    
                                                 string  fs_ListOfWorkingSMB,        //   
                                                 string  fs_BaseCurrency,            //   
                                                 string  fs_BadCurrency,             // "׸"  (   )
                                                 int     fi_MAXspread = 0,           //  
                                                 string  fs_Delimiter = ",")         //    
{
   ResetLastError();
   int li_CntOfSMB = 0;

   //----    
   if (fs_ListOfWorkingSMB == "")
   {
      string lsa_AllSymbols[],      //      (      )
             lsa_ProperCUR[],       //     
             lsa_BadCUR[];          //     
      int    li_CntProperCUR,       //    
             li_CntBadCUR,          //    
             li_Cnt = 0,            //      
             li_CUR,                //    
             li_BAD;                //    
      bool   lb_BAD;

      //----      
      li_CntProperCUR = CArraysMan.MakeStrArrayFromLine (fs_BaseCurrency, lsa_ProperCUR, ",");

      //----    ""  
      li_CntBadCUR = CArraysMan.MakeStrArrayFromLine (fs_BadCurrency, lsa_BadCUR, ",");

      //----       " "
      li_Cnt = ListOfSMB (lsa_AllSymbols, True);

      ArrayResize (fsa_WorkingSMB, li_Cnt);

      if (li_CntProperCUR == 0)
      {
         li_CntProperCUR = 1;
         ArrayResize (lsa_ProperCUR, 1);
      }

      CArraysMan.InitializeArraySTR (fsa_WorkingSMB, "");
Print ("_LastError_1 = ", _LastError);
      //----    ,    "" 
      for (int li_SMB = 0; li_SMB < li_Cnt; li_SMB++)
      {
         Print ("_LastError_2 = ", _LastError);
         for (li_CUR = 0; li_CUR < li_CntProperCUR; li_CUR++)
         {
            ResetLastError();
            Print ("_LastError_3 = ", _LastError);
            if (StringFind (lsa_AllSymbols [li_SMB], lsa_ProperCUR [li_CUR]) >= 0 || fs_BaseCurrency == "")
            {
//               Print ("_LastError_6 = ", _LastError);
               if (li_CntBadCUR > 0)
               {
//                //----    "" 
                  lb_BAD = false;
                   
                  for (li_BAD = 0; li_BAD < li_CntBadCUR; li_BAD++)
                  {
                     if (StringFind (lsa_AllSymbols [li_SMB], lsa_BadCUR [li_BAD]) >= 0)
                     {
                        lb_BAD = true; break;
                     }
                  }
                  
                  if (lb_BAD) break;
               }
//               Print ("_LastError_7 = ", _LastError);
               //----    "" 
               if (MaxSpread > 0)
               {
                  if (  MarketInfo (lsa_AllSymbols [li_SMB], MODE_SPREAD) > MaxSpread)
                  break;
               }
               fsa_WorkingSMB [li_CntOfSMB] = lsa_AllSymbols [li_SMB];
               li_CntOfSMB++;
               break;
            }
         }
      }
      Print ("_LastError_4 = ", _LastError);
      ArrayResize (fsa_WorkingSMB, li_CntOfSMB);
   }
   else
   {
      li_CntOfSMB = CArraysMan.MakeStrArrayFromLine (fs_ListOfWorkingSMB, fsa_WorkingSMB, ",");
      //----       
      li_CntOfSMB = CheckPresenceSMBInMarket (fsa_WorkingSMB);
   }
   //----   
   CLogging.Printing (StringConcatenate ("CreatWorkingSMBArray() => ", CErrs.ErrorToString (_LastError)));
//----
   return (li_CntOfSMB);
}
// 1.2     . ======================================================================================
int MakeListOfInstruments::ListOfSMB (string& fsa_SMB[],      //      
                                      bool    fb_Overview)    // True -  ` `
{
   static bool   lb_FirstRun = true;
          int    li_Offset,
                 li_CountOfSMB;
          string ls_NameOfFile,
                 ls_Txt;
//----
   if (fb_Overview)                       //----     ` `
   {
      ls_NameOfFile = "symbols.sel";
   }
   else                                   //--- (        )
   {
      ls_NameOfFile = "symbols.raw";
   }

   //----       
   int hFile = FileOpenHistory (ls_NameOfFile, FILE_READ|FILE_BIN);
    
   if (hFile < 0)
   {
      Print ("   ", ls_NameOfFile, ": ", _LastError);
      return (-1);
   }

   //----    ,    
   if (fb_Overview)                       //----     ` `
   {
      li_CountOfSMB = (int) (( FileSize (hFile) - 4 ) / 128);
      li_Offset = 116;
   }
   else                                   //--- (        )
   {
      li_CountOfSMB = (int) (FileSize (hFile ) / 1936);
      li_Offset = 1924;
   }
   ArrayResize (fsa_SMB, li_CountOfSMB);

   //----     4 ,    MQL
   if (fb_Overview)
   {
      if (!FileSeek (hFile, 4, SEEK_SET))
      {
          Print ("C     4   symbols.sel ", ls_NameOfFile, "  : ", _LastError);
      }
   }

   //----         symbols.sel
   for (int i = 0; i < li_CountOfSMB; i++)
   {
      fsa_SMB[i] = FileReadString (hFile, 12);
        
      if (!FileSeek (hFile, li_Offset, SEEK_CUR))
      {
          Print ("    li_Offset   symbols.sel ", ls_NameOfFile, "  : ", _LastError);
      }
   }
   FileClose (hFile);

   //----        
   if (lb_FirstRun)
   {
      if (fb_Overview)
      {
         ls_Txt = "  ` ` ";
      }
      else
      {
         ls_Txt = ",   ";
      }
      Print ("   ", ls_Txt, AccountCompany(), "  ", li_CountOfSMB);
      lb_FirstRun = false;
   }

   //----    
   return (li_CountOfSMB);
}
// 1.3       . =================================================================================
int MakeListOfInstruments::CheckPresenceSMBInMarket (string &fsa_WorkingSMB[])
{
   bool lb_RealTrade = CBase.GetRealTrade();
   
   if (!lb_RealTrade) return (1);

//----
   string lsa_Copy[];        //    
   int    li_Cnt = 0,
          li_Size = ArraySize (fsa_WorkingSMB);

//----
   ArrayResize (lsa_Copy, li_Size);
   ArrayCopy (lsa_Copy, fsa_WorkingSMB);
 
   for (int li_SMB = 0; li_SMB < li_Size; li_SMB++)
   {
      if (MarketInfo (lsa_Copy [li_SMB], MODE_BID) == 0.0)
      {
         Print (AccountCompany(), "   ", lsa_Copy [li_SMB]); continue;
      }
      fsa_WorkingSMB [li_Cnt] = lsa_Copy [li_SMB];
      li_Cnt++;
   }
   if (li_Size != li_Cnt) ArrayResize (fsa_WorkingSMB, li_Cnt);

//----
   return (li_Cnt);
}

#endif